Attribute VB_Name = "MainMod"
Option Explicit
    
'ev[g
Private Const TempFileName = "template.dat"

Type GPSPoint
  DateNum As Long
  DateStr As String
  Latitude As Double
  Longitude As Double
  Altitude As Double
  Speed As Double
  AccumDist As Double
End Type

'HTMLp[cAXe[Wf[^
Dim HTMLPart As New Collection
Dim Photos As New Collection
Dim GPSLog As New Collection
Dim GPSFile As String
Dim GPSFirstUTC&, GPSLastUTC&
Dim TotalDist As Double
Dim AvgSpeed As Double

Sub Main()
Dim HTMLData As String

'ev[gǂݍ
If ReadTemplate() = False Then
  MsgBox "template.datǂ݂߂܂", , "G["
  Exit Sub
End If

'Xe[Wf[^ǂݍ
GPSFile = Command
If GPSFile = "" Then GPSFile = GetOpenName
If GPSFile = "" Then Exit Sub

Call ShowMsgWin.Show
Call ShowProcess("GPSf[^͒")

If ReadGPSData(GPSFile) = False Then
  MsgBox GPSFile + "ǂ݂߂܂", , "G["
  Unload ShowMsgWin
  Exit Sub
End If

GPSFirstUTC = &H7FFFFFFF
GPSLastUTC = 0

'
HTMLData = CreateHTMLData
If HTMLData <> "" Then Call SaveHTMLData(GPSFile, HTMLData)
Unload ShowMsgWin
  
End Sub

Sub ShowProcess(ByVal msg As String)

ShowMsgWin.Label1.Caption = msg
DoEvents

End Sub

'-------------------------------
' ȉt@C
'-------------------------------

Sub SaveHTMLData(ByVal StageFileName As String, ByVal HTMLData As String)
Dim i&, HTMLFileName$, fnum&
Dim buf() As Byte
't@C

't@Cgq菜
HTMLFileName = StageFileName
For i = Len(StageFileName) To 1 Step -1
  If Mid(StageFileName, i, 1) = "." Then '납u . vTĂ
    HTMLFileName = Left(StageFileName, i - 1) + ".html"
    Exit For
  End If
Next

If Right(Space(5) + HTMLFileName, 5) <> ".html" Then HTMLFileName = HTMLFileName + ".html"

'ۑ
Call StringtoUTF8(HTMLData, buf)

fnum = FreeFile
Open HTMLFileName For Output As fnum
Close fnum
Open HTMLFileName For Binary As fnum
  Put #fnum, , buf
Close fnum

End Sub


Function ReadTemplate() As Boolean
Dim fn As String, TempFile$
Dim fnum As Long, Temp$, key$, Value$
Dim b As Boolean

'ev[g擾
fn = App.Path
If Right(fn, 1) <> "\" Then fn = fn + "\"
fn = fn + TempFileName

If Dir(fn) = "" Then
  MsgBox TempFileName + "܂"
  Exit Function
End If

fnum = FreeFile
Open fn For Input As fnum

'ݒ擾
key = "body"

Do Until EOF(fnum)

  Line Input #fnum, Temp
  b = False
  If Len(Temp) Then
    b = (Left(Temp, 1) = "*")
  End If
  
  If b Then
    '擪*Ȃ烌R[hI
    Call HTMLPart.Add(Value, key)
    'c̓L[̖O
    key = Right(Temp, Len(Temp) - 1)
    Value = ""
  Else
    If Value <> "" Then Value = Value + vbCrLf
    Value = Value + Temp
  End If
Loop

Call HTMLPart.Add(Value, key)

ReadTemplate = True

Close

End Function

Function ReadGPSData(ByVal GPSFileName As String) As Boolean
Dim fn As String
Dim fnum As Long, Temp$, Title$, Value$, RecType$
Dim b As Boolean
Dim l As Long
't@CI[v

If Dir(GPSFileName) = "" Then
  MsgBox GPSFileName + "܂"
  Exit Function
End If

fnum = FreeFile
Open GPSFileName For Input As fnum

'ݒ擾
Do Until EOF(fnum)

  Line Input #fnum, Temp
  l = l + 1
  If l Mod 100 = 0 Then Call ShowProcess("GPSf[^͒F" + CStr(l) + "s")
  
  '&GPRMCR[h$GPGGAR[ĥݗp
  RecType = Left(Temp + "       ", 7)
  If RecType = "$GPRMC," Or RecType = "$GPGGA," Then Call GPSLog.Add(Temp)
Loop


ReadGPSData = True

Close

End Function





'------------------------------------------
' ȉC̃Ro[g


Function CreateHTMLData() As String
Dim Body$, RecordList$, PhotoList$, nentry&
Dim Record&, Temp$
Dim Points() As GPSPoint

'Oϊ
nentry = ConvertGPSPoint(GPSLog, Points)

'[g̏AXe[W[v
For Record = 0 To nentry - 1
  If Record Mod 100 = 0 Then Call ShowProcess("[gf[^o͒F" + CStr(Record) + "/" + CStr(GPSLog.Count))
  Temp = CreateRecordHTML(Record, Points(Record))
  'GPGGA͍xL^
  If Temp <> "" Then RecordList = RecordList + Temp + vbCrLf
Next

PhotoList = CreatePhotoHTML()

'ʍڂ̒u
Body = HTMLPart("body")
Body = ReplaceString(Body, "[recordlist]", RecordList)
Body = ReplaceString(Body, "[photolist]", PhotoList)
Body = ReplaceString(Body, "[filename]", GPSFile)
Body = ReplaceString(Body, "[numrecord]", GPSLog.Count)
Body = ReplaceString(Body, "[numphoto]", Photos.Count)
Body = ReplaceString(Body, "[totaldist]", Format(TotalDist, "###.#0"))
Body = ReplaceString(Body, "[avgspeed]", Format(AvgSpeed, "###.#0"))
CreateHTMLData = Body

End Function

Function CreateRecordHTML(ByVal Record As Long, ByRef Point As GPSPoint) As String
Dim RecordList$

RecordList = GetHash(HTMLPart, "recordlist")
RecordList = ReplaceString(RecordList, "[index]", CStr(Record))
RecordList = ReplaceString(RecordList, "[time]", Format(Point.DateNum, "@@@@@@@@@@"))
RecordList = ReplaceString(RecordList, "[timestr]", Point.DateStr)
RecordList = ReplaceString(RecordList, "[lat]", Format(Point.Latitude, "###.###0"))
RecordList = ReplaceString(RecordList, "[lng]", Format(Point.Longitude, "###.###0"))
RecordList = ReplaceString(RecordList, "[alt]", Format(Point.Altitude, "####.#0"))
RecordList = ReplaceString(RecordList, "[dist]", Format(Point.AccumDist, "####.#0"))
RecordList = ReplaceString(RecordList, "[speed]", Format(Point.Speed, "####.#0"))

CreateRecordHTML = RecordList


End Function


Function CreatePhotoHTML() As String
Dim PhotoList$
Dim GPSPath$, l&, i&, PhotoFile$
Dim Temp$
Dim CurDate As Date, BaseDate As Date

BaseDate = DateSerial(1970, 1, 1)
Temp = GetHash(HTMLPart, "photolist")

't@CpX߂邽ߍŌ"\"T
For i = 1 To Len(GPSFile)
  If Mid(GPSFile, i, 1) = "\" Then l = i
Next

GPSPath = IIf(l > 0, Left(GPSFile, l), ".\") + "*.jpg"



PhotoFile = Dir(GPSPath)
Do While PhotoFile <> ""
  Call ShowProcess("摜f[^Exif͒F" + PhotoFile)
  CurDate = AnalyzeEXIF(PhotoFile)
  '1970/1/1̎Ԃ߂
  '^C][JPƑz
  
  If CLng(CurDate) > 0 Then
    l = CLng((CDbl(CurDate - BaseDate) * 24 - 9) * 60 * 60)
  
    If l >= GPSFirstUTC And l <= GPSLastUTC Then
      Call Photos.Add(PhotoList)
      PhotoList = Temp
      PhotoList = ReplaceString(PhotoList, "[id]", CStr(Photos.Count))
      PhotoList = ReplaceString(PhotoList, "[file]", CStr(PhotoFile))
      PhotoList = ReplaceString(PhotoList, "[time]", Format(CStr(l), "@@@@@@@@@@"))
      PhotoList = ReplaceString(PhotoList, "[timestr]", Format(CurDate, "yyyy/mm/dd hh:nn:ss"))
      CreatePhotoHTML = CreatePhotoHTML + PhotoList + vbCrLf
    End If
  End If
  
  PhotoFile = Dir
Loop




End Function

Function ConvertGPSPoint(ByRef log As Collection, ByRef Points() As GPSPoint)
Dim Temp As Variant
Dim GTime&, GDate&, Lat#, Lng#
Dim RecordList$, l&
Dim CurDate As Date, BaseDate As Date, DateNum&, TimeStr As String
Dim PreAlt!
Dim entry As Long, i&
Dim RecordStr$



ReDim Points(log.Count) As GPSPoint
entry = 0

For i = 1 To log.Count
  RecordStr = log(i)

  'GGAR[h獂x擾
  If Left(RecordStr, 6) = "$GPGGA" Then
    Temp = SplitString(RecordStr, ",")
    If UBound(Temp) >= 9 Then PreAlt = Val(Temp(9))
    GoTo nextloop
  End If
  
  '̒o
  Temp = SplitString(RecordStr, ",")
  If UBound(Temp) < 9 Then Exit Function
  GTime = Val(Temp(1))
  GDate = Val(Temp(9))
  Lat = Val(Temp(3))
  Lng = Val(Temp(5))

  'ܓxoxZo
  'GPS͏_ȉ100AGoogleMap60
  Lat = (Lat \ 100) + (Lat - 100 * (Lat \ 100)) / 60
  Lng = (Lng \ 100) + (Lng - 100 * (Lng \ 100)) / 60
  If Temp(4) = "S" Then Lat = -Lat
  If Temp(6) = "W" Then Lng = -Lng
  
  'VB`̎UTC`ɕϊ
  If Len(Temp(1)) = 6 And Len(Temp(9)) = 6 Then
    '1970/1/1̎Ԃ߂
    CurDate = DateSerial(2000 + (GDate Mod 100), (GDate \ 100) Mod 100, GDate \ 10000) _
      + TimeSerial(GTime \ 10000, (GTime \ 100) Mod 100, GTime Mod 100)
    BaseDate = DateSerial(1970, 1, 1)
    'bɕϊ
    l = CLng(CDbl(CurDate - BaseDate) * 60 * 60 * 24)
    If l < GPSFirstUTC Then GPSFirstUTC = l
    If l > GPSLastUTC Then GPSLastUTC = l
    
    DateNum = CLng(CDbl(CurDate - BaseDate) * 60 * 60 * 24)
  Else
    DateNum = "0"
  End If
    
  With Points(entry)
    .Latitude = Lat
    .Longitude = Lng
    .Altitude = PreAlt
    .DateNum = DateNum
    .DateStr = Format(CurDate + GetTimeDiff / 60 / 24, "yyyy/mm/dd hh:nn:ss")
  End With
  entry = entry + 1
nextloop:
Next

ReDim Preserve Points(entry) As GPSPoint

'̎Zo
Points(0).AccumDist = 0
For i = 1 To entry - 1
  Points(i).AccumDist = Points(i - 1).AccumDist + _
    CalcDistance(Points(i - 1).Latitude, Points(i - 1).Longitude, _
      Points(i).Latitude, Points(i).Longitude)
Next

'x̎Zo
TotalDist = Points(entry - 1).AccumDist

For i = 1 To entry - 2
  Points(i).Speed = 3600 * (Points(i + 1).AccumDist - Points(i - 1).AccumDist) / _
                    (Points(i + 1).DateNum - Points(i - 1).DateNum)
Next
'ŏƍŌ͂Q_Ԃ̋
If entry > 1 Then
  Points(0).Speed = Points(1).AccumDist / (Points(1).DateNum - Points(0).DateNum)
  Points(entry - 1).Speed = 3600 * (Points(entry - 1).AccumDist - Points(entry - 2).AccumDist) / _
                            (Points(entry - 1).DateNum - Points(entry - 2).DateNum)
  AvgSpeed = TotalDist * 3600 / (Points(entry - 1).DateNum - Points(0).DateNum)
End If



ConvertGPSPoint = entry

End Function

